package org.glassfish.bug.service;

import java.io.Serializable;
import java.util.Map;

import javax.persistence.CollectionTable;
import javax.persistence.Column;
import javax.persistence.ElementCollection;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.MapKeyColumn;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;

/**
 * Table alias CHRG.
 *
 */
@Entity
@NamedQueries({
@NamedQuery(
        name = "Charger.byAttr",
        query = "select c from Charger c join c.locationAttributes cc where key(cc) = :attrKey and value(cc) = :attrValue") })
@Table(name = "CHARGER")
public class Charger implements Serializable {

    @Id
    @Column(name = "CHRG_ID", nullable = false)
    private Long id;

    @ElementCollection
    @MapKeyColumn(name = "ATTR_KEY")
    @Column(name = "ATTR_VALUE")
    @CollectionTable(name = "CHRG_LOCATION_ATTR", joinColumns = @JoinColumn(name = "CHRG_ID"),
            uniqueConstraints = @UniqueConstraint(columnNames = { "CHRG_ID", "ATTR_KEY" }))
    private Map<String, String> locationAttributes;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Map<String, String> getLocationAttributes() {
        return locationAttributes;
    }

    public void setLocationAttributes(Map<String, String> locationAttributes) {
        this.locationAttributes = locationAttributes;
    }

}
